<?php

/*
 Appligent, Inc.
 22 East Baltimore Avenue
 Lansdowne, PA 19050
 USA
 (610) 284-4006
 http://www.appligent.com
 copyright 2010 Appligent, Inc.
*/

	error_reporting(E_ALL);
	ini_set('display_errors',true);

//
//a php class to act as a wrapper for running
//various Appligent products
//
	class AppligentPHPClasses
	{

		protected
			$debug = false,
			$appName = '',
			$appPath = '',
			$cmd = '',
			$cmdEnd = '',
			$licenseCode = '',
			$optionalCmds = '',
			$fullCmdLine = '',
			$inputFile = '',
			$outputFile = '',
			$logFile = '',
			$ownerPass = '',
			$incrementalSave = false,
			$linearize = false,
			$optimize = false,
			$nocomp = false,
			$comp = false,
			$iso32000 = false,
			$encrypt = false,
			$keylength = '',
			$newOwnerPass = '',
			$newUserPass = '',
			$noPrint = false,
			$noModify = false,
			$noCopy = false,
			$noNotes = false,
			$noFill = false,
			$noAccess = false,
			$noAssembly = false,
			$noHighRes = false,
			$showProgress = false,
			$showVersion = false;

		public function AppligentPHPClasses()
		{
		}

		public function SetDebugMode($pDebug)
		{
			$this->debug = $pDebug;
		}

		public function SetApplicationName($pAppName)
		{
			$this->appName = $pAppName;
		}

		public function SetApplicationPath($pAppPath)
		{
			$this->appPath = $pAppPath;
		}
		
		protected function AddCmd($pCmd)
		{
			$this->cmd .= $pCmd;
		}

		protected function SetCommandEnd($pCmdEnd)
		{
			$this->cmdEnd = $pCmdEnd;
		}

		public function SetLicenseCode($pLicenseCode)
		{
			$this->licenseCode = $pLicenseCode;
		}

		public function SetOwnerPass($pOwnerPass)
		{
			$this->ownerPass = $pOwnerPass;
		}

		public function SetInputFile($pInputFile)
		{
			$this->inputFile = $pInputFile;
		}

		public function SetOutputFile($pOutputFile)
		{
			$this->outputFile = $pOutputFile;
		}

		public function SetLogFile($pLogFile)
		{
			$this->logFile = $pLogFile;
		}

		public function SetCommandLine($pFullCmdLine)
		{
			$this->fullCmdLine = $pFullCmdLine;
		}

		public function SetIncrementalSave($pIncrementalSave)
		{
			$this->incrementalSave = $pIncrementalSave;
		}

		public function SetLinearize($pLinearize)
		{
			$this->linearize = $pLinearize;
		}

		public function SetOptimize($pOptimize)
		{
			$this->optimize = $pOptimize;
		}

		public function SetNocomp($pNocomp)
		{
			$this->nocomp = $pNocomp;
		}

		public function SetComp($pComp)
		{
			$this->comp = $pComp;
		}

		public function SetIso32000($pIso32000)
		{
			$this->iso32000 = $pIso32000;
		}

		public function SetEncrypt($pEncrypt)
		{
			$this->encrypt = $pEncrypt;
		}

		public function SetKeylength($pKeylength)
		{
			$this->keylength = $pKeylength;
		}

		public function SetNewOwnerPass($pNewOwnerPass)
		{
			$this->newOwnerPass = $pNewOwnerPass;
		}

		public function SetNewUserPass($pNewUserPass)
		{
			$this->newUserPass = $pNewUserPass;
		}

		public function SetNoPrint($pNoPrint)
		{
			$this->noPrint = $pNoPrint;
		}

		public function SetNoModify($pNoModify)
		{
			$this->noModify = $pNoModify;
		}

		public function SetNoCopy($pNoCopy)
		{
			$this->noCopy = $pNoCopy;
		}

		public function SetNoNotes($pNoNotes)
		{
			$this->noNotes = $pNoNotes;
		}

		public function SetNoFill($pNoFill)
		{
			$this->noFill = $pNoFill;
		}

		public function SetNoAccess($pNoAccess)
		{
			$this->noAccess = $pNoAccess;
		}

		public function SetNoAssembly($pNoAssembly)
		{
			$this->noAssembly = $pNoAssembly;
		}

		public function SetNoHighRes($pNoHighRes)
		{
			$this->noHighRes = $pNoHighRes;
		}

		public function SetShowProgress($pShowProgress)
		{
			$this->showProgress = $pShowProgress;
		}

		public function SetShowVersion($pShowVersion)
		{
			$this->showVersion = $pShowVersion;
		}

		public function SetOptionalCmds($pOptionalCmds)
		{
			$this->optionalCmds = $pOptionalCmds;
		}

//
//run the application with the previously given parameters;
//return status code & application output to caller
//
		public function Run(&$retAppOutput)
		{

//if full command line was given, use it
			if (strlen($this->fullCmdLine) > 0)
				$this->cmd = $this->fullCmdLine;
			else
			{

//add user specified items to command line
				if (strlen($this->licenseCode) >0 )
					self::AddCmd("-r $this->licenseCode ");

				if (strlen($this->outputFile) > 0)
					self::AddCmd("-o $this->outputFile ");

				if (strlen($this->logFile) > 0)
					self::AddCmd("-l $this->logFile ");


				if (strlen($this->ownerPass) > 0)
					self::AddCmd("-d $this->ownerPass ");

				if ($this->incrementalSave)
					self::AddCmd("-i ");

				if ($this->linearize)
					self::AddCmd("-w ");

				if ($this->optimize)
					self::AddCmd("-optimize ");

				if ($this->nocomp)
					self::AddCmd("-nocomp ");

				if ($this->comp)
					self::AddCmd("-comp ");

				if ($this->iso32000)
					self::AddCmd("-iso32000 ");

				if ($this->encrypt)
					self::AddCmd("-encrypt ");

				if (strlen($this->keylength) > 0)
					self::AddCmd("-keylength $this->keylength ");

				if (strlen($this->newOwnerPass) > 0)
					self::AddCmd("-ownerpass $this->newOwnerPass ");

				if (strlen($this->newUserPass) > 0)
					self::AddCmd("-userpass $this->newUserPass ");

				if ($this->noPrint)
					self::AddCmd("-noprint ");

				if ($this->noModify)
					self::AddCmd("-nomodify ");

				if ($this->noCopy)
					self::AddCmd("-nocopy ");

				if ($this->noNotes)
					self::AddCmd("-nonotes ");

				if ($this->noFill)
					self::AddCmd("-nofill ");

				if ($this->noAccess)
					self::AddCmd("-noaccess ");

				if ($this->noAssembly)
					self::AddCmd("-noassembly ");

				if ($this->noHighRes)
					self::AddCmd("-nohighres ");

				if ($this->showProgress)
					self::AddCmd("-p ");

				if ($this->showVersion)
					self::AddCmd("-v ");

			}		//else part of: if (strlen($this->fullCmdLine) > 0)

//add path to app & app name to beginning of command line 
			$this->cmd = $this->appPath . $this->appName . ' ' . $this->cmd;

//and final command line items (usually input files)
			$this->cmd .= $this->cmdEnd;

//initialize return variables
			$appOutput=array();
			$appRet=0;

//if debug mode is on, just output the command line, without
//running the application
			if ($this->debug)
				print "cmd: '$this->cmd'\n\n";
			else
				exec($this->cmd, $appOutput, $appRet);

			$retAppOutput = $appOutput;
			return $appRet;
		}
	}

?>

