<?php

/*
 Appligent, Inc.
 22 East Baltimore Avenue
 Lansdowne, PA 19050
 USA
 (610) 284-4006
 http://www.appligent.com
 copyright 2010 Appligent, Inc.
*/

	error_reporting(E_ALL);
	ini_set('display_errors',true);

	require_once('AppligentPHPClasses.php');

//
//a php class to act as a wrapper for running
//Appligent's StampPDF Batch product
//
	class AppligentStampPDF extends AppligentPHPClasses
	{

//define the application name
		const appName='stamppdfapp';

		protected
			$stampFile = '',
			$removeOldStamps = false,
			$undoLabel = '',
			$batesCharCount = 0;
		
		public function AppligentStampPDF()
		{
			parent::__construct();
			parent::SetApplicationName(self::appName);
		}

		public function SetRemoveOldStamps($pUndoLabel)
		{
			$this->removeOldStamps = true;
			$this->undoLabel = $pUndoLabel;			
		}

		public function SetBatesCharCount($pBatesCharCount)
		{
			$this->batesCharCount = $pBatesCharCount;
		}

		public function SetStampFile($pStampFile)
		{
			$this->stampFile = $pStampFile;
		}


//
//run the application with the previously given parameters;
//return status code & application output to caller
//
		public function Run(&$retAppOutput)
		{


//add user specified items to command line
			if ($this->removeOldStamps)
				parent::AddCmd("-u $this->undoLabel ");

			if ($this->batesCharCount > 0)
				parent::AddCmd("-j $this->batesCharCount ");

//stamp file and input file must be at the end of the command line
			$cmdEnd = '';

			if (strlen($this->stampFile) > 0)
				$cmdEnd .= "$this->stampFile ";

			if (strlen($this->inputFile) > 0)
				$cmdEnd .= "$this->inputFile ";

			parent::SetCommandEnd($cmdEnd);
			parent::Run($retAppOutput);

		}		//function Run()
	}
?>
